/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.checkup_booking;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface CheckupBookingRpcService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.checkup_booking.CheckupBookingRpcService";
    String SERVICE_NAME = "com.ywt.gapi.checkup_booking.CheckupBookingRpcService";

        /**
         * <pre>
         *  套餐等级 id
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetAnnouncementResponse getAnnouncement(com.ywt.gapi.checkup_booking.GetAnnouncementRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetAnnouncementResponse> getAnnouncementAsync(com.ywt.gapi.checkup_booking.GetAnnouncementRequest request){
        return CompletableFuture.completedFuture(getAnnouncement(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getAnnouncement(com.ywt.gapi.checkup_booking.GetAnnouncementRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetAnnouncementResponse> responseObserver){
        getAnnouncementAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  套餐等级名称
         * </pre>
         */
    com.ywt.gapi.checkup_booking.CreateOrderResponse createOrder(com.ywt.gapi.checkup_booking.CreateOrderRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.CreateOrderResponse> createOrderAsync(com.ywt.gapi.checkup_booking.CreateOrderRequest request){
        return CompletableFuture.completedFuture(createOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createOrder(com.ywt.gapi.checkup_booking.CreateOrderRequest request, StreamObserver<com.ywt.gapi.checkup_booking.CreateOrderResponse> responseObserver){
        createOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  科室代码
         * </pre>
         */
    com.ywt.gapi.checkup_booking.CancelOrderResponse cancelOrder(com.ywt.gapi.checkup_booking.CancelRegRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.CancelOrderResponse> cancelOrderAsync(com.ywt.gapi.checkup_booking.CancelRegRequest request){
        return CompletableFuture.completedFuture(cancelOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void cancelOrder(com.ywt.gapi.checkup_booking.CancelRegRequest request, StreamObserver<com.ywt.gapi.checkup_booking.CancelOrderResponse> responseObserver){
        cancelOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  HIS套餐ID
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetOrderListResponse getOrderList(com.ywt.gapi.checkup_booking.GetOrderListRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetOrderListResponse> getOrderListAsync(com.ywt.gapi.checkup_booking.GetOrderListRequest request){
        return CompletableFuture.completedFuture(getOrderList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOrderList(com.ywt.gapi.checkup_booking.GetOrderListRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetOrderListResponse> responseObserver){
        getOrderListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         *  类型描述
         * </pre>
         */
    com.ywt.gapi.checkup_booking.GetNoticeResponse getPackageNotice(com.ywt.gapi.checkup_booking.GetNoticeRequest request);

    default CompletableFuture<com.ywt.gapi.checkup_booking.GetNoticeResponse> getPackageNoticeAsync(com.ywt.gapi.checkup_booking.GetNoticeRequest request){
        return CompletableFuture.completedFuture(getPackageNotice(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getPackageNotice(com.ywt.gapi.checkup_booking.GetNoticeRequest request, StreamObserver<com.ywt.gapi.checkup_booking.GetNoticeResponse> responseObserver){
        getPackageNoticeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
